<?php
/**
 * Core Design Ajax Admin Utility (AJAU) plugin for Joomla! 1.5
 */


class AJAU {

	/*
	 * Disable plugin
	 *
	 * Disable plugin if necessary
	 *
	 * @return boolean	true to disable plugin
	 */
	function disable() {

		jimport('joomla.enviroment.request');
		$task = JRequest::getCmd('task');

		$disable = array();
		$disable []= 'add';
		$disable []= 'edit';
		$disable []= 'movesect';
		$disable []= 'copy';
		$disable []= 'element';

		if ($task and in_array($task, $disable)) {
			return true;
		}
	}

	/*
	 * Language
	 *
	 * Language strings inserted to header
	 *
	 * @return array	language strings
	 */
	function language() {

		// set language strings
		$language_strings = array();
		$language_strings []= 'AJAU_LOADING';
		$language_strings []= 'AJAU_FACEBOX_CLOSE_TITLE';
		$language_strings []= 'AJAU_WINDOW_MESSAGE';
		$language_strings []= 'AJAU_SUCCESS_MESSAGE';
		$language_strings []= 'AJAU_ERROR_MESSAGE';
		$language_strings []= 'AJAU_AJAX_ERROR';
		$language_strings []= 'AJAU_SELECT_ITEM';
		$language_strings []= 'AJAU_SELECTCAT';

		return $language_strings;
	}

	/*
	 * Option
	 *
	 * Option strings inserted to header
	 *
	 * @return array	option strings
	 */
	function option() {
		$option_strings = array();

		$get_option = JRequest::getCmd('option', '', 'get');
		
		$option_strings []= 'option' . '|' . $get_option;

		return $option_strings;
	}
	
	// Run tasks
	function runTask($task = '') {
		if (!$task) {
			return false;
		}
		
		$msg = null;
		
		switch ($task) {
			case 'moveArticle':
			case 'copyArticle':
				$msg = AJAU::categoryList();
				break;
			default:
				break;
		}
		return $msg;
		
	}
	
	/*
	 * Load category list
	 * 
	 * Form for moving item(s) to a different section and category
	 * 
	 * return string	category selectlist
	 */
	function categoryList() {
		
		// Initialize variables
		$db	= & JFactory::getDBO();
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		
		//seperate contentids
		$cids = implode(',', $cid);
		
		// Articles query
		$query = 'SELECT a.title' .
				' FROM #__content AS a' .
				' WHERE ( a.id IN ( '. $cids .' ) )' .
				' ORDER BY a.title';
		$db->setQuery($query);
		$items = $db->loadObjectList();

		$query = 'SELECT CONCAT_WS( ", ", s.id, c.id ) AS `value`, CONCAT_WS( " / ", s.title, c.title ) AS `text`' .
				' FROM #__sections AS s' .
				' INNER JOIN #__categories AS c ON c.section = s.id' .
				' WHERE s.scope = "content"' .
				' ORDER BY s.title, c.title';
		$db->setQuery($query);
		
		$rows[] = JHTML::_('select.option', "", '- ' . JText::_('AJAU_SELECTCAT') . ' -');
		$rows[] = JHTML::_('select.option', "0, 0", JText::_('UNCATEGORIZED'));
		$rows = array_merge($rows, $db->loadObjectList());
		
		// build the html select list
		$sectCatList = JHTML::_('select.genericlist',  $rows, 'sectcat', 'class="inputbox" size="1" style="width: 200px;"', 'value', 'text', null);
		
		return $sectCatList;
	}

}

?>