/**
 * Application - com_content
 */
 
 (function($) {
 	
	$.ajau_com_content = {
		
		initiator: function () { 
			
			$.ajau.initFacebox(); // init Facebox settings
			$.ajau.toolbar($.ajau_com_content.toolbarItems()); // create menu			
			$.ajau_com_content.refresh(); // refresh table.adminlist
		},
		
		// Create menu
		toolbarItems: function() {
			var toolbar = new Array();
			toolbar.push('publish');
			toolbar.push('unpublish');
			toolbar.push('archive');
			toolbar.push('unarchive');
			toolbar.push('trash');
			toolbar.push('move');
			toolbar.push('copy');
			return toolbar;
		},
		
		// Refresh form if Ajax request loads the whole adminForm
		refresh: function() {
			
			$.ajau_com_content.filtering(); // enable search filtering (ajax)
			
			var tr = $.ajau.adminFormTR();
			
			tr.each(function (element) {
				var elem = $(this);
				
				if ($.ajau.tableCell(elem, 1).find('input').length < 1) {
					return true;
				}
				
				// publish/Unpublish icons
				$.ajau.tableCell(elem, 3).find('a').removeAttr('onclick').click(function(e) {
					e.preventDefault();					
					$.ajau_com_content.manageStatus(elem, $(this));
					
				}).find('img').attr('alt', '');
				
				// frontpage toggle icons
				$.ajau.tableCell(elem, 4).find('a').removeAttr('onclick').attr('title', '').click(function(e) {
					e.preventDefault();
					$.ajau_com_content.manageFrontpage(elem, $(this));
				}).find('img').attr('alt', '');
				
				// access level
				$.ajau.tableCell(elem, 6).find('a').removeAttr('onclick').click(function(e) {
					e.preventDefault();
					$.ajau_com_content.changelevel(elem);
				});
				
				// ordering arows
				$.ajau.tableCell(elem, 5).find('a').removeAttr('onclick').click(function(e) {
					e.preventDefault();
					$.ajau_com_content.manageArrow(elem, $(this));
				});			
			});
			
			// pagination
			var pagecontainer = $('.pagination');
			var pagelinks = pagecontainer.find('.page a');
			
			var limit = $.ajau.adminForm().find('input[name="limitstart"]:hidden');
			var countlimit = $('select[name="limit"]').removeAttr('onchange').change( function () {
				$.ajau.ping();
			}).val();
			
			pagelinks.click(function(e) {
				e.preventDefault();
				var vallimit = countlimit * ( $(this).attr('title') - 1 );
				limit.val(vallimit);
				$.ajau.ping();
				
			}).removeAttr('onclick');
			
			// next and end buttons
			var next_end = pagecontainer.find('.start a, .prev a, .next a, .end a');
			next_end.click( function(e) {
				e.preventDefault();
				
				switch ($(this).parent().attr('class')) {
					case 'start':
						var first_num = pagecontainer.find('.page a:first').attr('title');
						limit.val( countlimit * ( first_num - 1 ) );
						break;
					case 'prev':
						var start_num = pagecontainer.find('.page span').prev('a').attr('title');
						limit.val( countlimit * ( start_num - 1 ) );
						break;
					case 'next':
						var next_num = pagecontainer.find('.page span').next('a').attr('title');
						limit.val( countlimit * ( next_num - 1 ) );
						break;
					case 'end':
						var end_num = pagecontainer.find('.page a:last').attr('title');
						limit.val( countlimit * ( end_num - 1 ) );
						break;
					default:
						return true;
						break;
				}
				$.ajau.ping();
				
			}).removeAttr('onclick');
			
			// ordering
			var th_links = $.ajau.adminForm().find('.adminlist thead tr th a');
			
			var direction = '';
			
			switch ($.ajau.filename(th_links.children('img').attr('src'))) {
				case 'sort_desc.png':
					direction = 'asc';
					break;
				case 'sort_asc.png':
					direction = 'desc';
					break;
				default:
					break;
			}
			
			th_links.each( function() {
				
				var href = $(this).attr('href');
				
				$(this).attr('href', '#');
				
				var order = '';
				
				if (href.indexOf('\'c.title\'') != -1) {
					order = 'c.title';
				} else if (href.indexOf('\'c.state\'') != -1) {
					order = 'c.state';
				} else if (href.indexOf('\'frontpage\'') != -1) {
					order = 'frontpage';
				} else if (href.indexOf('\'section_name\'') != -1) {
						order = 'section_name';
				} else if (href.indexOf('\'groupname\'') != -1) {
						order = 'groupname';
				} else if (href.indexOf('\'section_name\'') != -1) {
						order = 'section_name';
				} else if (href.indexOf('\'cc.name\'') != -1) {
						order = 'cc.name';
				} else if (href.indexOf('\'author\'') != -1) {
						order = 'author';
				} else if (href.indexOf('\'c.created\'') != -1) {
						order = 'c.created';
				} else if (href.indexOf('\'c.hits\'') != -1) {
						order = 'c.hits';
				} else if (href.indexOf('\'c.id\'') != -1) {
						order = 'c.id';
				} else if (href.indexOf('\'saveorder\'') != -1) {
					order = 'saveorder';
				} else {
					return true;
				}
				
				$(this).click(function(e) {
					e.preventDefault();
					
					if (order == 'saveorder') {
						$.ajau.inputs(true);
						$.ajau.setTask('saveorder');
						$.ajau.ping();
					} else {
						$.ajau.adminForm().find('input[name="filter_order"]:hidden').val(order);
						$.ajau.adminForm().find('input[name="filter_order_Dir"]:hidden').val(direction);
						$.ajau.ping();
					}
				});
			});
		},
		
		// Manage publish/unpublish status
		manageStatus: function(elem, this_link) {
			$.ajau.removeTooltip(); // remove Mootools tooltip
			
			switch($.ajau.filename(this_link.find('img').attr('src'))) {
				case 'publish_x.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.changeContent('publish');
					break;
				case 'publish_g.png':
				case 'publish_r.png':
				case 'publish_y.png':
				case 'disabled.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.changeContent('unpublish');
					break;
				default:
					return false;
					break;
			}
		},
		
		// Manage Frontpage icons
		manageFrontpage: function(elem, this_link) {
			switch($.ajau.filename(this_link.find('img').attr('src'))) {
				case 'disabled.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.toggleFrontPage('toggle_frontpage');
					break;
				case 'publish_x.png':
				case 'tick.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.toggleFrontPage('toggle_frontpage');
					break;
				default:
					return false;
					break;
			}
		},
		
		// Manage order arrows
		manageArrow: function(elem, this_link) {
			switch($.ajau.filename(this_link.find('img').attr('src'))) {
				case 'downarrow.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.mover('orderdown');
					break;
				case 'uparrow.png':
					$.ajau.checkInput(elem);
					$.ajau_com_content.mover('orderup');
					break;
				default:
					return false;
					break;
			}
		},
		
		// Action for toolbars - unpublish
		toolbarpublish: function() {
			if ( $.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau_com_content.changeContent('publish');
			}
		},
		
		// Action for toolbars
		toolbarunpublish: function() {		
			if ($.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau_com_content.changeContent('unpublish');
			}
		},
		
		// Action for toolbars - archive
		toolbararchive: function() {			
			if ($.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau_com_content.changeContent('archive');
			}
		},
		
		// Action for toolbars - archive
		toolbarunarchive: function() {
			if ($.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau_com_content.changeContent('unarchive');
			}
		},
		
		// Action for toolbars - trash
		toolbartrash: function() {
			if ($.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau_com_content.remove('remove');
			}
		},
		
		// Move article
		toolbarmove: function() {
			if ( $.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau.ping('moveArticle');
			}
		},
		
		// Move article
		toolbarcopy: function() {
			if ( $.ajau.getcids().length < 1) {
				alert($.ajau.language.AJAU_SELECT_ITEM);
				return false;
			} else {
				$.ajau.ping('copyArticle');
			}
		},
		
		copyArticle: function(msg) {
			$.ajau.windowBox($.ajau.language.AJAU_SELECTCAT, msg);
			var selectlist = $('#facebox .content select');
			selectlist.click( function() {
				
				if(!$(this).val()) return false;
				$.ajau.setTask('copysave');
				$.ajau.closeFacebox();
				
				var data = $.ajau.adminForm().serialize() + '&' + $(this).serialize();
				$.ajau.ping('ping', data);
			});
		},
		
		// Process category list
		moveArticle: function(msg) {
			$.ajau.windowBox($.ajau.language.AJAU_SELECTCAT, msg);
			var selectlist = $('#facebox .content select');
			selectlist.click( function() {
				
				if(!$(this).val()) return false;
				$.ajau.setTask('movesectsave');
				$.ajau.closeFacebox();
				
				var data = $.ajau.adminForm().serialize() + '&' + $(this).serialize();
				$.ajau.ping('ping', data);
			});
		},
		
		// Publish / unpublish function
		changeContent: function (task) {
			if (!task) return false;
			$.ajau.setTask(task);
			$.ajau.ping();
		},
		
		// Toggle frontpage
		toggleFrontPage: function(task) {
			if (!task) return false;
			$.ajau.setTask(task);
			$.ajau.ping();
		},
		
		// Remove article from view
		remove: function (task) {
			if (!task) return false;
			$.ajau.setTask(task);
			$.ajau.ping();
		},
		
		// Change level procedure
		changelevel: function (element) {
			
			var level_cell = $.ajau.tableCell(element, 6); // get table > tr > td cell with level info
			
			switch (level_cell.find('a').css('color')) {
				case 'green':
				case '#008000':
					task = 'accessregistered';
					break;
				case 'red':
				case '#ff0000':
					task = 'accessspecial';
					break;
				case 'black':
				case '#000000':
					task = 'accesspublic';
					break;
				default:
					task = '';
					break;
			}
			
			// prevent empty task
			if (!task) {
				return false;
			}
			
			$.ajau.checkInput(element);
			$.ajau.setTask(task);
			$.ajau.ping();
			
		},		
		
		// Mover wrapper
		mover: function (task) {
			$.ajau.setTask(task);
			$.ajau.ping();
		},
		
		// Manage search filter
		filtering: function () {
			
			// filters
			var search = $.ajau.adminForm().find('input#search');
			var filter_sectionid = $.ajau.adminForm().find('select#filter_sectionid');
			var catid = $.ajau.adminForm().find('select#catid');
			var filter_authorid = $.ajau.adminForm().find('select#filter_authorid');
			var filter_state = $.ajau.adminForm().find('select#filter_state');
			
			// buttons
			var button_first = $.ajau.adminForm().find('input#search + button');
			var button_second = $.ajau.adminForm().find('input#search + button + button');
			
			// find adminForm selects
			var selects = $.ajau.adminForm().find('table:eq(0)').find('input#search, select, button').removeAttr('onclick').removeAttr('onchange');
			
			selects.each(function() {
				var element = $(this);				

				if (element.is('select')) {
					element.change( function () {
						$.ajau.ping();
					});
				}
				if (element.is('input')) {
					element.keypress( function (e) {
						if (e.which == 13) {
							e.preventDefault();
							$.ajau.ping();
						}
					});
				}
				if (element.is('button')) {
					element.click( function (e) {
						e.preventDefault();
						if (!element.prev('input').length) {							
							selects.filter('input#search').val('');
							selects.filter('select#filter_sectionid').val('-1');
							selects.filter('select#catid').val('0');
							selects.filter('select#filter_authorid').val('0');
							selects.filter('select#filter_state').val('');
						}
						$.ajau.ping();
					});
				}				
			});
		},
		
		// Process ping ajax request
		ping: function(msg) {
			$.ajau.adminForm().replaceWith(msg);
			$.ajau_com_content.refresh();
		}
	};
})(jQuery);