/**
 * Application - AJAU
 */

(function($) {
	$.ajau = {
		
		// Return adminForm
		adminForm: function () {
			var form = $('form[name="adminForm"]');
			if (form) {
				return form;
			} else {
				return null;
			}
		},
		
		// Return form with name "adminForm"
		adminFormTR: function () {
			var tr = $.ajau.adminForm().find("table.adminlist > tbody > tr");
			
			if (!tr) {
				return '';
			} else {
				return tr;
			}
		},
		
		// Retrieve all checked inputs from adminForm
		getcids: function() {
			var tr = $.ajau.adminFormTR();
			
			var td = $.map(tr.find('td:eq(1)').children('input:checked'), function(element) {
				return $(element).val();
			});
			
			return td;
			
		},
		
		// return actual table > tr row based on "id" by input
		getTr: function (cid) {			
			var tr = $.ajau.adminFormTR().find("input[value='" + cid + "']").parent().parent();
			return tr;
		},
		
		// Get token - Joomla! security!!!
		token: function (formname) {
			
			if (!formname) {
				formname = 'adminForm';
			}
			
			var token = $("form[name='" + formname + "'] > :hidden:last").eq(0).attr('name');
			
			if (!token) {
				return '';
			} else {
				return token;
			}
		},
		
		// Set task
		setTask: function(task) {
			if (!task) task = '';
			$.ajau.adminForm().find('input[name="task"]:hidden').val(task);
		},
		
		// Get table cell
		tableCell: function (element, num) {
			if (num == '' || num == null) {
				num = 0;
			}
			var tableCell = element.children('td').eq(num); // get actual article link
			return tableCell;
		},
		
		// Loading text
		loading: function (msg) {
			
			var loading = '';
			
			if (!msg) {
				loading = $('<span class="ajau_loading">' + $.ajau.language.AJAU_LOADING + '</span>');
			} else {
				loading = $('<span class="ajau_loading">' + msg + '</span>');
			}			
			
			var is_loading = $('body').find('.ajau_loading');
			
			if (is_loading.length) {
				is_loading.remove();
			} else {
				$('body').prepend(loading);
			}
		},
		
		// Check specified input
		checkInput: function(tr) {
			$.ajau.inputs(false); // uncheck all inputs
			// check just once necessary input
			var cid = $.ajau.tableCell(tr, 1).children('input').attr('checked', true);
		},
		
		// Check all inputs in second cell in adminForm
		inputs: function(checked) {
			
			if (!checked) {
				checked == true;
			}
			
			$.ajau.tableCell($.ajau.adminFormTR(), 1).children('input[name="cid\[\]"]').attr('checked', true);;
			
			$.ajau.adminFormTR().each(function() {
				var td = $.ajau.tableCell($(this), 1);
				
				if (checked == true) {
					td.children('input[name="cid\[\]"]').attr('checked', true);
				} else {
					td.children('input[name="cid\[\]"]').attr('checked', false);
				}
			});
		},
		
		// Remove Mootools tooltips
		removeTooltip: function() {
			$('.tool-tip').remove();
		},
		
		// Facebox settings
		initFacebox: function () {
			if ($.facebox) {
				$.facebox.settings.loadingImage = '../plugins/system/cdajau/js/facebox/loading.gif';
				$.facebox.settings.closeImage = '../plugins/system/cdajau/js/facebox/closelabel.png';
				$.facebox.settings.opacity = '0.4';
				$.facebox.settings.faceboxHtml = '\
				    <div id="facebox" style="display:none;"> \
				      <div class="popup"> \
				        <table> \
				          <tbody> \
				            <tr> \
				              <td class="tl"/><td class="b"/><td class="tr"/> \
				            </tr> \
				            <tr> \
				              <td class="b"/> \
				              <td class="body"> \
				                <div class="content"> \
				                </div> \
				                <div class="footer"> \
				                  <a href="#" class="close"> \
				                    <img src="/facebox/closelabel.gif" title="' + $.ajau.language.AJAU_FACEBOX_CLOSE_TITLE + '" class="close_image" /> \
				                  </a> \
				                </div> \
				              </td> \
				              <td class="b"/> \
				            </tr> \
				            <tr> \
				              <td class="bl"/><td class="b"/><td class="br"/> \
				            </tr> \
				          </tbody> \
				        </table> \
				      </div> \
				    </div>';
			}
		},
		
		// Check if facebox is enabled - if yes, then close
		closeFacebox: function () {
			if ($.facebox) {
				$(document).trigger('close.facebox');
			}
		},
		
		// Load info message box
		windowBox: function (header, msg) {
			if (!msg) msg = '';
			if (!header) header = $.ajau.language.AJAU_WINDOW_MESSAGE;
			$.facebox('<h2 class="ajau_window">' + header + '</h2><p>' + msg + '</p>');
		},
		
		// Load success message box
		successBox: function (msg) {
			if (!msg) {
				msg = '';
			}
			$.facebox('<h2 class="ajau_success">' + $.ajau.language.AJAU_SUCCESS_MESSAGE + '</h2><p>' + msg + '</p>');
		},
		
		// Load error message box
		errorBox: function (msg) {
			if (!msg) {
				msg = '';
			}
			$.facebox('<h2 class="ajau_warning">' + $.ajau.language.AJAU_ERROR_MESSAGE + '</h2><p>' + msg + '</p>');
		},
		
		// Create menu
		toolbar: function (items) {
			
			items.each( function(it) {
				var toolbar = $('#toolbar tbody tr #toolbar-' + it);
				var action = it;
				var a_inner = toolbar.children('a').html();
				var htmlelement = '<a href="#" class="toolbar" onclick="jQuery(document).ready( function($) { $.ajau_' + $.ajau.settings.option + '.toolbar' + action + '(); });" title=""></a>';
				toolbar.children('a').replaceWith(htmlelement);
				toolbar.children('a').html(a_inner);
				
				// prevent click event
				toolbar.children('a').click( function(e) {
					e.preventDefault();
				});
			});
			
		},
		
		// Return filename from path to this file, e.g. "images/stories/my_image.png" returns "my_image.png"
		filename: function(filepath) {
			return filepath.substring(filepath.lastIndexOf('/')+1);
		},
		
		// Ping site and replace adminForm
		ping: function(func, data) {
			
			if (!func) func = 'ping';
			
			// if no data, serialize default adminForm
			if (!data) data = $.ajau.adminForm().serialize(); // prepare adminForm data for post 
			
			// is some data, append "&" to start
			if (data) {
				data = '&' + data;
			}
			
			$.ajau.loading();
			
			$.ajax({
				type: 'POST',
				timeout: 8000,
				data: 'ajau=' + func + data,
				cache: false,
				success: function(msg) {
					if (!msg) msg = '';
					// call function wrapper - example: $.ajau_com_content.ping();
					var fcname = '$.ajau_' + $.ajau.settings.option + '.' + func + '(msg)';
					eval(fcname);
				},
				complete: function() {
					$.ajau.loading();
				},
				error: function() {
					$.ajau.errorBox($.ajau.language.AJAU_AJAX_ERROR);
				}
			});
		}
	};
})(jQuery);